"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const TypeScriptVueExtensionConfiguration_1 = require("./extension/vue/TypeScriptVueExtensionConfiguration");
function createTypeScriptReporterConfiguration(compiler, options) {
    let tsconfig = typeof options === 'object' ? options.tsconfig || 'tsconfig.json' : 'tsconfig.json';
    // ensure that `tsconfig` is an absolute normalized path
    tsconfig = path_1.default.normalize(path_1.default.isAbsolute(tsconfig)
        ? tsconfig
        : path_1.default.resolve(compiler.options.context || process.cwd(), tsconfig));
    const optionsAsObject = typeof options === 'object' ? options : {};
    return Object.assign(Object.assign({ enabled: options !== false, memoryLimit: 2048, build: false, mode: 'readonly' }, optionsAsObject), { tsconfig: tsconfig, context: optionsAsObject.context || path_1.default.dirname(tsconfig), compilerOptions: Object.assign({ skipDefaultLibCheck: true, skipLibCheck: true }, (optionsAsObject.compilerOptions || {})), extensions: {
            vue: TypeScriptVueExtensionConfiguration_1.createTypeScriptVueExtensionConfiguration(optionsAsObject.extensions ? optionsAsObject.extensions.vue : undefined),
        }, diagnosticOptions: Object.assign({ syntactic: false, semantic: true, declaration: false, global: false }, (optionsAsObject.diagnosticOptions || {})) });
}
exports.createTypeScriptReporterConfiguration = createTypeScriptReporterConfiguration;
